<?php
################################################################################
# @Name : mail2ticket.php
# @Desc : convert mail to ticket
# @call : 
# @parameters : 
# @Author : Flox
# @Create : 07/04/2013
# @Update : 22/11/2016
# @Version : 3.1.13
################################################################################

//define encodage type 
header('Content-Type: text/html; charset=utf-8');

//initialize variables 
if(!isset($_GET['id'])) $_GET['id'] = ''; 

//call phpimage components
require_once('components/PhpImap/IncomingMail.php');
require_once('components/PhpImap/Mailbox.php');
use PhpImap\Mailbox as ImapMailbox;
use PhpImap\IncomingMail;
use PhpImap\IncomingMailAttachment;

//function to add attachment in image on ticket
function func_attachement($c_ticket_number,$c_name_dir_upload,$mail,$db)
{
	$c_name_dir_ticket = $c_name_dir_upload.$c_ticket_number; 
	@mkdir($c_name_dir_upload.$c_ticket_number);

	//move attachment to upload directory
	$tabAttachments = $mail->getAttachments();
	foreach ($tabAttachments as $tabAttachment){
		//case image inside in mail
		if($tabAttachment->disposition=="") 
		{
			$c_name_file = basename($tabAttachment->filePath);
		} 
		//case attachment in mail
		else 
		{
			$c_name_file = $tabAttachment->name;
			$query=$db->query("SELECT img1,img2,img3,img4,img5 FROM tincidents WHERE id LIKE '$_GET[id]'");
			$row=$query->fetch();
			$query->closeCursor();

			//find the first free slot else not display attach input
			if ($row['img1']=="") {$freeslot="img1";}
			else if ($row['img2']=="") {$freeslot="img2";}
			else if ($row['img3']=="") {$freeslot="img3";}
			else if ($row['img4']=="") {$freeslot="img4";}
			else if ($row['img5']=="") {$freeslot="img5";}

			if(isset($freeslot)){
				$stmt = $db->prepare("UPDATE tincidents SET $freeslot=:freeslot WHERE id=:id");
				$stmt->bindParam(':freeslot', $c_name_file);
				$stmt->bindParam(':id', $c_ticket_number);
				$stmt->execute();
			}
		}
		rename($tabAttachment->filePath,$c_name_dir_ticket.'/'.$c_name_file); 
	}
	return $mail->replaceInternalLinks('upload/'.$c_ticket_number);
}

//initialize counter
$count=0;

//connexion script with database parameters
require "connect.php";

//switch SQL MODE to allow empty values with lastest version of MySQL
$db->exec('SET sql_mode = ""');

//define current time
$datetime = date("Y-m-d H:i:s");

//load parameters table
$query=$db->query("SELECT * FROM tparameters");
$rparameters=$query->fetch();
$query->closeCursor(); 

//hostname building
$hostname = '{'.$rparameters['imap_server'].':'.$rparameters['imap_port'].'}'.$rparameters['imap_inbox'].'';

//connect to inbox
echo "<u></u>Connexion à la boite au lettre en cours: <font color=green>ok</font><br /><br />";
$c_name_dir_upload =  __DIR__.'/upload/';
$con_mailbox = new PhpImap\Mailbox($hostname, $rparameters['imap_user'], $rparameters['imap_password'],$c_name_dir_upload) or die('Impossible de se connecter au serveur de Messagerie: ' . imap_last_error());
if (!$con_mailbox ) {
	die("Erreur de connexion IMAP");
}

//check mail in mailbox
$mailsIds = $con_mailbox ->searchMailBox('ALL');
if(!$mailsIds) {
    die('Mailbox is empty');
}

//treatment for all mail inside mailbox
$tab_MailsInfos =  $con_mailbox ->getMailsInfo($mailsIds); 
foreach ($tab_MailsInfos as $tab_MailsInfo){
	if($tab_MailsInfo->seen==0) 
	{
		$count=$count+1;
		$mail = $con_mailbox ->getMail($tab_MailsInfo->uid);
		//move mail into read folder
		//$con_mailbox->moveMail($tab_MailsInfo->uid,'INBOX/vu'); 
		if($mail->textHtml == NULL){
        	 $message = nl2br($mail->textPlain);
		}else{
        	 $message = $mail->textHtml;
		}
		$subject = $mail->subject;
		$from = $mail->fromAddress;

		//special char convert
		$subject = str_replace('_', ' ', $subject);

		//find gestsup userid from mail address
		$query=$db->query("SELECT id FROM `tusers` where mail='$from' ");
		$row=$query->fetch();
		$query->closeCursor();
		if($row[0])
		{
			$user_id=$row[0];
		} else {
			$user_id='0';
			$c_FromMessage='De '.$from.':<br />';
		}
		
		//detect ticket number in subject to update an existing ticket
		$c_reg = "/n°(.*?):/i"; //regex for extract ticket number
		preg_match($c_reg, $subject, $matches); // extract ticket number
		@$find_ticket_number = $matches[1];
		if ($find_ticket_number!="")
		{
			//get attachement and image 
			$message = (isset($c_FromMessage)?$c_FromMessage:'').func_attachement($find_ticket_number,$c_name_dir_upload,$mail,$db); 

			//get only answer from mail
			$message=explode("pour le ticket n",$message);
			$message=$message[0];
			$message=substr($message,0,-130);

			//update ticket
			$stmt = $db->prepare("INSERT INTO tthreads (ticket,date,author,text) VALUES (?,?,?,?)");
			$stmt->bindParam(1, $find_ticket_number);
			$stmt->bindParam(2, $datetime);
			$stmt->bindParam(3, $user_id);
			$stmt->bindParam(4, $message);
			$stmt->execute();

			echo "&nbsp> Import du message $count mise a jour d'un ticket existant: $subject: <font color=green>ok</font><br />";
			
			//update unread state
			$db->exec("UPDATE tincidents SET techread=0 WHERE id='$find_ticket_number'");
			
		} else {
			//create ticket
			$stmt = $db->prepare("INSERT INTO tincidents  (user,technician,title,description,date_create,techread,state,criticality,disable,place) 
			 			VALUES (?,'0',?, '',?,'0','5','4','0','0')");
			$stmt->bindParam(1, $user_id);
			$stmt->bindParam(2, $subject);
			$stmt->bindParam(3, $datetime);
			$stmt->execute();
			
			//get ticket number
			$c_ticket_number = $db->lastInsertId();
			//get attachement and images from mail
			$message = (isset($c_FromMessage)?$c_FromMessage:'').func_attachement($c_ticket_number,$c_name_dir_upload,$mail,$db);

			$stmt = $db->prepare("UPDATE tincidents set description=:description WHERE id=:id");
			$stmt->bindParam(':description', $message);
			$stmt->bindParam(':id', $c_ticket_number);
			$stmt->execute();

			echo "&nbsp> Import du message $count création de ticket n° $c_ticket_number : $subject: <font color=green>ok</font><br />";
		}
	}
}

//imap_close($inbox);
echo "<br />Total: Récupération de $count messages depuis <b>$rparameters[imap_server]</b> depuis le port <b>$rparameters[imap_port]</b><br />";

?>